﻿using YEA.Monitor.LogManager;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.IO;
using log4net;

namespace LogManager_Test
{
    
    
    /// <summary>
    ///This is a test class for LoggerTest and is intended
    ///to contain all LoggerTest Unit Tests
    ///</summary>
    [TestClass()]
    public class LoggerTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion

        public static string nspace = "YEA.Monitor.LogManager";


        /// <summary>
        ///A test for Get
        ///</summary>
        [TestMethod()]
        public void GetTest()
        {
            string name = nspace;
            ILog actual = Logger.Get(name);
            actual.Fatal("testMessage");
            Assert.IsTrue(actual.IsFatalEnabled);
        }

        /// <summary>
        ///A test for CreateDir
        ///</summary>
        [TestMethod()]
        [DeploymentItem("YEA.Monitor.LogManager.dll")]
        public void CreateDirTest()
        {
            string name = @"D:\Log\TestDir"; 
            Logger_Accessor.CreateDir(name);
            Assert.IsTrue(Directory.Exists(name));
        }

        /// <summary>
        ///A test for ConvertToPath
        ///</summary>
        [TestMethod()]
        [DeploymentItem("YEA.Monitor.LogManager.dll")]
        public void ConvertToPathTest()
        {
            string name = nspace;
            string expected = @"D:\YEA\Monitor";
            string actual;
            actual = Logger_Accessor.ConvertToPath(name);
            Assert.AreEqual(expected, actual);
        }
    }
}
