﻿using System;
using System.Threading;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using YEA.Infrastructure.Gateway;
using YEA.Monitor.LogService;
using YEA.Utilities.Common;

namespace Test.Sample.Configuration.AMQP
{
    
    
    /// <summary>
    ///This is a test class for ControllerTest and is intended
    ///to contain all ControllerTest Unit Tests
    ///</summary>
    [TestClass()]
    public class ControllerTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for Start
        ///</summary>
        [TestMethod()]
        public void StartTest()
        {
            Controller target = new Controller(
                new TestGatewayFactory( 
                    new RabbitMQ.Client.Exceptions.OperationInterruptedException( 
                        new RabbitMQ.Client.ShutdownEventArgs(RabbitMQ.Client.ShutdownInitiator.Application, 2, "test" )
                    )
                 )
            ); // TODO: Initialize to an appropriate value
            target.Start();
            Assert.AreEqual("this", "this");
        }
        /// <summary>
        ///A test for Start
        ///</summary>
        [TestMethod()]
        public void StartServiceStateControllerTest()
        {
            var target = new ServiceStateController(
                new TestGatewayFactory(
                    new RabbitMQ.Client.Exceptions.OperationInterruptedException(
                        new RabbitMQ.Client.ShutdownEventArgs(RabbitMQ.Client.ShutdownInitiator.Application, 2, "test")
                    )
                 )
            ); // TODO: Initialize to an appropriate value
            target.Start();
            Assert.AreEqual("this", "this");
        }

        [TestMethod()]
        public void StartRealTest()
        {
            Controller target = new Controller();
            target.Start();
            Assert.AreEqual("this", "this");
        }
    }

    public class TestGatewayFactory : IGatewayFactory
    {
        private Exception ex;
        public TestGatewayFactory(Exception ex)
        {
            this.ex = ex;
        }
        public IAsyncConsumerProcessor GetAsyncReceiver(string ReceiverName, MessageConsumer handler)
        {
             return new TestAsyncReceiver(ex);
        }

        public IPublisher GetPublisher(string PublisherName, ConvertToMessage converter)
        {
            return new TestPublisher();
        }
        public void Dispose()
        {
            ex = null;
        }
    }


    public class TestPublisher : IPublisher
    {
        public string Exchange
        {
            get { return "testExchange"; }
        }

        public bool Mandatory
        {
            get { return true; ; }
        }

        public bool Immediate
        {
            get { return false; ; }
        }

        public void Publish(object ObjectToPublish)
        {
            throw new FakeException("Test Exception");
        }
    }
    public class TestAsyncReceiver : IAsyncConsumerProcessor
    {
        private static int counter = 0;
        private string queue;

        public string Queue
        {
            get
            {
                return queue; ;
            }
            set
            {
                queue = value ;
            }
        }

        public TestAsyncReceiver( Exception ex)
        {
            Thread.Sleep(100);
            if (counter++ < 10)
                throw ex;
            else if (counter < 15)
                throw new FakeException("Test Exception");
            Thread.Sleep(10000);
        }

        public void Stop()
        {
            throw new FakeException( "Test Exception");
        }
    }


}
