﻿using YEA.Infrastructure.Gateway;
using YEA.Infrastructure.Gateway.Stubs;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using RabbitMQ.Client;

namespace Test.YEA.Infrastructure.Gateway
{
    
    
    /// <summary>
    ///This is a test class for PublisherTest and is intended
    ///to contain all PublisherTest Unit Tests
    ///</summary>
    [TestClass()]
    public class PublisherTest : IConvertToMessage
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for Publish
        ///</summary>
        [TestMethod()]
        public void PublishTest()
        {
            IConnection connection = new NullConnection();
            ConvertToMessage converter = ConvertObjectToMessage ;
            string exchange = "test";
            Publisher target = new Publisher(connection, converter, exchange);
            object ObjectToPublish = null;
            try
            {
                target.Publish(ObjectToPublish);
                Assert.Fail("The publisher failed to recognize a null object to publish parameter");
            }
            catch( ApplicationException ex)
            {
                Assert.IsTrue( ex is ApplicationException);
            }
        }

        /// <summary>
        ///A test for Publisher Constructor
        ///</summary>
        [TestMethod()]
        public void PublisherConstructorTestNullConnection()
        {
            IConnection connection = null;
            ConvertToMessage converter = ConvertObjectToMessage;
            string exchange = "test";
            try
            {
                Publisher target = new Publisher(connection, converter, exchange);
                Assert.Fail("Publisher constructor failed to throw an exception when a null connection parameter was passed");
            }
            catch (ApplicationException ex)
            {
                Assert.IsTrue(ex is ApplicationException);
            }
        }
        [TestMethod()]
        public void PublisherConstructorTestNullConverter()
        {
            IConnection connection = new NullConnection();
            ConvertToMessage converter = null;
            string exchange = "test";
            try
            {
                Publisher target = new Publisher(connection, converter, exchange);
                Assert.Fail("Publisher constructor failed to throw an exception when a null converter parameter was passed");
            }
            catch (ApplicationException ex)
            {
                Assert.IsTrue(ex is ApplicationException);
            }
        }
        [TestMethod()]
        public void PublisherConstructorTestEmptyExchange()
        {
            IConnection connection = new NullConnection();
            ConvertToMessage converter = ConvertObjectToMessage;
            string exchange = string.Empty;
            try
            {
                Publisher target = new Publisher(connection, converter, exchange);
                Assert.Fail("Publisher constructor failed to throw an exception when an empty exchange parameter was passed");
            }
            catch (ApplicationException ex)
            {
                Assert.IsTrue(ex is ApplicationException);
            }
        }

        public Message ConvertObjectToMessage(IModel channel, object packetToSend)
        {
            return new Message() { Body = null, Properties = null, RoutingKey = string.Empty };
        }
    }
}
